#include <SDObject.h>
#include <SDEvent.h>
#include <SDUIBase.h>
#include <SDUIXBase.h>
#include <SDWindow.h>
#include <SDXWindow.h>

Class SDXWindow_fast;

@implementation SDXWindow  
/*
{
 SDUIXBase * base ;
 Window    window ;
 GC gc 
 XWindowAttributes attributes;
}
*/

-(SDUIXBase *) base ;
{
 return base ;
}

-(id)base:(SDUIXBase *) _base ;
{
 base = _base ;
 return self ;
} 

-(GC)GC ;
{
 return gc ;
}

-(id)GC: (in GC) _gc ;
{
 gc = _gc ;
 return self ;
}

-(id)window: (Window) _window ;
{
 window = _window ;
 return self ;
}

-(Window ) window ;
{
 return window ;
}

-(id)getWindowAttributes:(out XWindowAttributes *) _attributes ;
{
 return self ;
}
-(id)setWindowAttributes:(in XWindowAttributes *) _attributes ;
{
 return self ;
}
-(id)restackWindow:(Window *) _array_window with:(int)_win_num ;
{
 return self ;
}


/* implementation SDWindow */

-(id)show ;
{
 XMapWindow(base->display , window );
 return self ;
}
-(id)showUp ;
{ 
 XMapRaised(base->display , window);
 return self ;
}

-(id)hide ;
{
 XUnmapWindow(base->display,window);
 return self ;
}

-(id)hideSubwindow ;
{
 XUnmapSubwindow(base->display,window);
 return self ;
}
-(id)clear ;
{
 XClearWindow(base->display, window);
 return self ;
}
-(id)flush ;
{
 [base flush];
 return self ;
}

-(id)destroy;
{
 XDestroyWindow(base->display , window);
 return self ;
}
-(id)destroySubwindows ;
{
 XDestroySubwindows(base->display ,window);
 return self ;
}
-(id)move:(int)_x with: (int)_y;
{
 XMoveWindow(base->display, window , _x , _y);
 return self ;
}

-(id)resize: (int)_width with:(int)_height ;
{
 XResizeWindow(base->display, window , _width, _height);
 return self ;
}
-(id)moveResize:(int)_x with:(int)_y with:(int)_width with:(int)_height ;
{
 XMoveResizeWindow(base->display , window , _x , _y , _width , _height );
 return self ;
}
-(id)changeParent: (SDWindow *)_window posX: (int) _x posY:(int)_y ;
{ 
 XReparentWindow(base->display , window , _window , _x ,_y);
 return self ;
}
-(id)raise ;
{
 XRaiseWindow(base->display , window); 
 return self ;
}

-(id)lower;
{
 XLowerWindow(base->display , window );
 return self ;
}

-(id)circulateSubwindows:(int)_direction ;
{
 XCirculateSubwindows(base->display, window , _direction);
 return self ;
}
-(id)circulateSubwindowDown ;
{
 XCirculateSubwindowsDown(base->display,window );
 return self ;
}
-(id)circulateSubwindowUp ;
{
 XCirculateSubwindowsUp(base->display,window );
 return self ;
}

@end 


