#include <SDObject.h>


@implementation SDObject 
{
 unsigned long mm_type ;
}

+(Class) self ;
{
 return self ;
} 
+(Class) class ;
{
 return self ;
} 
+(ulong ) instanceSize ;
{
 return ((Class) self)->instance_size  ;
} 
+(char * ) name ;
{
 return ((Class) self)->name ;
} 
+(bool)isClass;
{
 return (bool)(SD_OBJECT_IS_CLASS(self));
} 
+(bool)isMetaClass;
{
 return  (bool)(SD_OBJECT_IS_METACLASS(self));
}

+(Class) isExist ;
{
 return self ;
} 
+free ;
{
}

-(id) new ;
{
 return  [[self class] new];
} 

-(bool) isFalse  ;
{
 return false ;
}

-(bool) isTrue ;
{
 return false ;
} 

-(bool) isExist ;
{
 return true ;
} 

-(unsigned long) mmType ;
{
 return mm_type ;
} 
-(id) mmType: (unsigned long ) _type  ;
{
 mm_type = _type ;
 return self ;
}

-(id) removable ;
{
 mm_type  &= ~IRREMOVABLE ;
 return self ;
} 

-(id) editable ;
{
 mm_type  &= ~UNEDITABLE ;
 return self ;
}
-(id) extendable ;
{
 mm_type  &= ~UNEXTENDABLE ;
 return self ;
}

-(id) irremovable ;
{
  mm_type |= IRREMOVABLE  ;
 return self ;
}
 
-(id) uneditable ;
{
 mm_type |= UNEDITABLE  ;
 return self ;
}

-(id) unextendable ;
{
 mm_type |= UNEXTENDABLE  ;
 return self ;
}

-(id) stackInstance ;
{
 mm_type |= STACK_INSTANCE;
 return self ;
}

-(bool) isRemovable ;
{
 return (bool) ( ( (mm_type & IRREMOVABLE ) == 0 )? false : true )  ;
}

-(bool) isEditable ;
{
 return (bool) (((mm_type & UNEDITABLE ) == 0 )? false : true );
}

-(bool) isExtendable ;
{
 return (bool) (( (mm_type & UNEXTENDABLE ) == 0  )? false : true  ) ;
}

-(bool) isStackInstance ;
{
 return (bool) ( ((mm_type & STACK_INSTANCE ) ==0)? false : true );
}

@end
