#ifndef INTERFACE_SDUIBase
#define INTERFACE_SDUIBase  1

@class SDEvent,SDWindow ;

extern Class SDUIBase_fast;


@interface SDUIBase : SDObject
{
 SDEvent * sd_event ;
} 

+setDefaultUI:(SDUIBase *) _default_ui ;

-init:(SDEvent *) _sd_event  ;

-(int)screenNumber ;
-(int)currentScreenNumber ;

-(SDEvent *)readOnlyEvent ;
-(SDEvent *)waitEvent ;
-(SDEvent *)waitEventSDWindow:(SDWindow *)_window ;

-(bool)nonWaitEvent: (inout SDEvent *) _event ;
-(SDEvent *)nonWaitEventSDWindow:(SDWindow* ) _window;

@end 

extern SDUIBase * default_uibase;

#endif
