#ifndef INTERFACE_SDXWindow
#define INTERFACE_SDXWindow  1

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>


@class SDUIXBase , SDUIBase , SDEvent ;

extern Class SDXWindow_fast;

@interface SDXWindow  : SDWindow
{
 @public
 SDUIXBase * base ;
 Window    window ;
 GC gc ;
 XWindowAttributes attributes;
}

-(SDUIXBase *) base ;
-(id)base:(SDUIXBase *) _base ;
-(GC)GC ;
-(id)GC: (in GC) _gc ;

-(id)window: (Window) _window ;
-(Window ) window ;

-(id)getWindowAttributes:(out XWindowAttributes *) _attributes ;
-(id)setWindowAttributes:(in XWindowAttributes *) _attributes ;
-(id)restackWindow:(Window *) _array_window with:(int)_win_num ;

@end 


#endif
